var loadflags = {
	storage: false,
	activetab: false,
	window: false
};

var settings = {
	extactive: true,
	invertonly: false
};

var blacklist = [
	'proxer.me',
	/*'discordapp.com',*/
	'codepen.io',
	'steampowered.com',
	'store.steampowered.com',
	'steamcommunity.com',
	'crosscode.gamepedia.com'
];

var rules = [
//	{host: '', css: ''}
];

var currenturl = null;

var storage = chrome.storage.sync;

var qs = document.querySelector.bind(document);
var btn = {};
var glob, loc;

window.addEventListener('load', function() {
	btn = {
		extactive: qs('input#extactive'),
		domactive: qs('input#domactive'),
		invertonly: qs('input#invertonly')
	};
	glob = qs('#global');
	loc = qs('#local');

	document.getElementById('webstore_support').addEventListener('click', function() {
		chrome.windows.create({
			url: 'https://chrome.google.com/webstore/detail/night-reader/oedepfdhcakemgfedefnaccnifpnljmb/support',
			type: 'popup'
		});
	});

	loadflags.window = true;
	if (loadflags.storage && loadflags.activetab) {
		load();
	}
});

var t = function(tabs) {
	if (!loadflags.window) {
		return setTimeout(function(){t(tabs);}, 50);
	}
	if (tabs.length > 0) {
		currenturl = new URL(tabs[0].url);
	} else {
		btn.domactive.disabled = true;
		btn.domactive.parentElement.style.color='rgba(0,0,0,0.5)';
	}
	
	loadflags.activetab = true;
	if (loadflags.window && loadflags.storage) {
		load();
	}
}
chrome.tabs.query({
	"active": true,
	"currentWindow": true,
	"status": "complete",
	"windowType": "normal"
}, t);

storage.get(['settings','blacklist'], function(items) {
	if (!items) {
		items = {};
	}
	if (items.settings) {
		settings = items.settings;
	}
	//console.log(JSON.stringify(settings));
	if (items.blacklist) {
		blacklist = items.blacklist;
	}

	loadflags.storage = true;
	if (loadflags.window && loadflags.activetab) {
		load();
	}
});


function load() {
	btn.extactive.checked = settings.extactive;
	btn.domactive.checked = (currenturl === null || blacklist.indexOf(currenturl.host) === -1);
	btn.invertonly.checked = settings.invertonly;
	//console.log(currenturl.host, blacklist.indexOf(currenturl.host));

	updatePopup();

	btn.extactive.addEventListener('click', function(e) {
		settings.extactive = this.checked;
		storage.set({'settings': settings}, function() {
			//console.log('saved: '+JSON.stringify(settings));
		});
		signalupdate({settings: settings});
	});
	if (currenturl !== null) {
		btn.domactive.title = btn.domactive.parentElement.title = currenturl.host;
	} else {
		if (location.hash !== '#test') {
			setTimeout(function(){location.reload();}, 1000);
		}
	}
	btn.domactive.addEventListener('click', function(e) {
		if (this.checked) {
			var index = blacklist.indexOf(currenturl.host);
			if (index >= 0) {
				blacklist.splice(index, 1);
			} else {
				//console.log('host already excluded from blacklist');
			}
		} else {
			blacklist.push(currenturl.host);
			blacklist = blacklist.sort();
		}
		storage.set({'blacklist': blacklist}, function() {
			//console.log('saved',blacklist.indexOf(currenturl.host) === -1 ? currenturl.host+' enabled' : currenturl.host+' disabled');
		});
		signalupdate({blacklist: blacklist});
	});
	btn.invertonly.addEventListener('click', function(e) {
		settings.invertonly = this.checked;
		storage.set({'settings': settings}, function() {
			//console.log('saved: '+JSON.stringify(settings));
		});
		signalupdate({settings: settings});
	});
}

function signalupdate(obj) {
	obj.update = true;
	chrome.tabs.query({/*active: true, currentWindow: true*/}, function(tabs) {
		for (var t in tabs) {
			chrome.tabs.sendMessage(tabs[t].id,obj);
		}
	});

	updatePopup();
}

function updatePopup() {
	if (settings.extactive) {
		if (settings.invertonly) {
			glob.classList.remove('no-inv', 'inv-rot');
			glob.classList.add('inv-only');
			if (currenturl === null || blacklist.indexOf(currenturl.host) === -1) {
				loc.classList.remove('no-inv', 'inv-rot');
				loc.classList.add('inv-only');
			} else {
				loc.classList.remove('inv-rot', 'inv-only');
				loc.classList.add('no-inv');
			}
		} else {
			glob.classList.remove('no-inv', 'inv-only');
			glob.classList.add('inv-rot');
			if (currenturl === null || blacklist.indexOf(currenturl.host) === -1) {
				loc.classList.remove('no-inv', 'inv-only');
				loc.classList.add('inv-rot');
			} else {
				loc.classList.remove('inv-rot', 'inv-only');
				loc.classList.add('no-inv');
			}
		}
	} else {
		glob.classList.remove('inv-rot','inv-only');
		glob.classList.add('no-inv');
		loc.classList.remove('inv-rot','inv-only');
		loc.classList.add('no-inv');
	}
};


function dumpdata() {
	return new Promise(function(resolve, reject) {
		storage.get(['settings','blacklist','rules'], function(items) {
			resolve(JSON.stringify(items));
		});
	});
}
